proc
	SQLFormat_Insert(_tbl, list/L)
		if(!L || !istype(L, /list))
			return 0

		var/i = 1
		var/list_len = length(L)

		. = "INSERT INTO `[_tbl]` ("
		for(i, i <= list_len, i++)
			. += "`[L[i]]`[i == list_len ? "":","]"
		. += ") VALUES ("
		i = 1
		for(i, i <= list_len, i++)
			var/j = L[i]
			var/value = L[j]
			. += "'[value]'[i == list_len ? "":","]"
		. += ")"

	SQLFormat_Select(_tbl, what = "*", cond = "WHERE 1")
		if(istext(what))
			. = "SELECT [what] FROM `[_tbl]` [cond]"
		else if(istype(what, /list))
			. = "SELECT "
			var/list/L = what
			var/list_len = length(L)
			for(var/i = 1, i <= list_len, i++)
				var/v = L[i]
				. += "[v][i == list_len ? "":","]"
			. += " FROM [_tbl] [cond]"

	SQLFormat_Update(_tbl, list/what, cond = "WHERE 1")
		if(istext(what))
			. = "UPDATE `[_tbl]` SET `[what]` WHERE [cond]"
		else if(istype(what, /list))
			. = "UPDATE `[_tbl]` SET "
			var/list_len = length(what)
			for(var/i = 1, i <= list_len, i++)
				var/v = what[i]
				. += "`[v]` = '[what[v]]'[i == list_len ? "":","]"
			. += " [cond]"

	SQLFormat_Delete(_tbl, cond = "WHERE 1")
		return "DELETE FROM `[_tbl]` [cond]"

	SQLFormat_SelectLastID(_tbl)
		return "SELECT LAST_INSERT_ID() FROM `[_tbl]`"